var gulp = require('gulp');
var sass = require('gulp-sass');
var sourcemap = require('gulp-sourcemaps');
var browserSync = require('browser-sync');
var autoprefixer = require('gulp-autoprefixer');
var cleanCss = require('gulp-clean-css');
var rename = require('gulp-rename');

var autoprefixerOptions = {
    browsers: ['last 2 versions']
};

var sassOptions = {
    outputStyle: 'expanded',
    errLogToConsole: true
};

gulp.task('sass', function () {
    return gulp.src('./src/sass/main.scss')
        .pipe(sourcemap.init())
        .pipe(sass(sassOptions).on('error', sass.logError))
        .pipe(autoprefixer(autoprefixerOptions))
        .pipe(sourcemap.write('./maps'))
        .pipe(gulp.dest('./dist/css'))
        .pipe(browserSync.stream())
});

gulp.task('clean', function () {
    console.log('clean.....');
    return gulp.src('./dist/css/*.css')
        .pipe(cleanCss())
        .pipe(rename({suffix: '.min'}))
        .pipe(gulp.dest('./dist/css'));
});

gulp.task('serve', ['sass'], function () {
    browserSync.init({
        server: './'
    });

    gulp.watch('./src/sass/**/*.scss', ['sass', 'clean']);
    gulp.watch('./*.html').on('change', browserSync.reload);
});

gulp.task('default', ['serve']);